package cn.ysk.cashier.service.product;

import cn.ysk.cashier.dto.product.TbProductSortCriteria;
import cn.ysk.cashier.pojo.product.TbProduct;
import cn.ysk.cashier.pojo.product.TbProductGroup;
import cn.ysk.cashier.dto.product.TbProductGroupDto;
import cn.ysk.cashier.dto.product.TbProductGroupQueryCriteria;
import cn.ysk.cashier.vo.AddProduct;
import org.springframework.data.domain.Pageable;
import org.springframework.http.ResponseEntity;

import java.util.Map;
import java.util.List;
import java.io.IOException;
import javax.servlet.http.HttpServletResponse;

/**
* @website https://eladmin.vip
* @description 服务接口
* @author lyf
* @date 2023-12-16
**/
public interface TbProductGroupService {

    /**
    * 查询数据分页
    * @param criteria 条件
    * @param pageable 分页参数
    * @return Map<String,Object>
    */
    Map<String,Object> queryAll(TbProductGroupQueryCriteria criteria, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param criteria 条件参数
    * @return List<TbProductGroupDto>
    */
    List<TbProductGroupDto> queryAll(TbProductGroupQueryCriteria criteria);


    List<TbProduct> findByIdProduct(Integer productGroup);
    /**
     * 根据ID查询
     * @param id ID
     * @return TbProductGroupDto
     */
    TbProductGroupDto findById(Integer id);

    /**
    * 创建
    * @param resources /
    * @return TbProductGroupDto
    */
    TbProductGroupDto create(TbProductGroup resources);

    /**
    * 编辑
    * @param resources /
    */
    void update(TbProductGroup resources);

    void upSort(TbProductSortCriteria param);
    /**
    * 多选删除
    * @param ids /
    */
    void deleteAll(Integer[] ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    void download(List<TbProductGroupDto> all, HttpServletResponse response) throws IOException;

    ResponseEntity<Object> updateProductIds(AddProduct addProduct, String userName);
}